package org.vraptor.mydvds.logic;

import org.vraptor.annotations.Component;
import org.vraptor.annotations.In;
import org.vraptor.annotations.InterceptedBy;
import org.vraptor.annotations.Out;
import org.vraptor.mydvds.interceptor.AuthorizationInterceptor;
import org.vraptor.mydvds.model.User;
import org.vraptor.scope.ScopeType;

/**
 * Será interceptada <code>AuthorizationInterceptor</code>.
 */
@Component("user")
@InterceptedBy(AuthorizationInterceptor.class)
public class LogoutComponent {

    @In(scope=ScopeType.SESSION)
    @Out(scope=ScopeType.SESSION)
    private User currentUser;

    /*
     * Injeta o usuário da sessão pelo construtor. 
     * 
     * Vraptor pega o currentUser da sessão (httpSession.getAttribute("currentUser");)
     * e injeta ele no construtor.
     * 
     * Podemos ter certeza que o usuario está na sessão, porque chamamos
     * <code>AuthorizationInterceptor</code> antes.
     */
    public LogoutComponent() {
    }

    public void logout() {
	this.currentUser = null;
    }
}
