package org.vraptor.mydvds.model;

import java.util.Set;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.ManyToMany;

import org.hibernate.validator.Length;
import org.hibernate.validator.NotNull;

/**
 * Entidade user. 
 * 
 * A classe representa a tabela user no banco de dados. 
 * 
 * Um objeto persistido dessa classe representa um registro no banco de dados. 
 */
@Entity
public class User {

	//chave primária
	@Id
	@GeneratedValue
	private Long id;

	//Anotações/regras do Hibernate validator
	@NotNull
	@Length(min = 3, max = 20)
	private String login;

	//Anotações/regras do Hibernate validator
	@NotNull
	@Length(min = 6, max = 20)
	private String password;

	//Anotações/regras do Hibernate validator
	@NotNull
	@Length(min = 3, max = 100)
	private String name;

	//mapeamento entre usuário e dvd,
	//lado responsável
	@ManyToMany
	private Set<Dvd> dvds;

	public Set<Dvd> getDvds() {
		return dvds;
	}

	public void setDvds(Set<Dvd> dvds) {
		this.dvds = dvds;
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getLogin() {
		return login;
	}

	public void setLogin(String login) {
		this.login = login;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getPassword() {
		return password;
	}

	public void setPassword(String password) {
		this.password = password;
	}

}
